
/* GLOBAL
  ===========================================================================*/

:root{

  /* --- SOFT RAW THEME --- */
  /* --back-clr: whitesmoke;
  --soft-clr: green;
  --acc-clr: blue ;
  --clr: #111; */

  /* --- SEASHELLS THEME --- */
  --back-clr: seashell;
  --soft-clr: hsl(210, 25%, 50%);
  --acc-clr: MediumSeaGreen ;
  --clr: #111;

  --space: 1em;
  --lh: 1.3;
}

html{
  background: var(--back-clr);
  color: var(--clr);
  line-height: var(--lh);

  /* font-family: sans-serif; */
  /* font-family: monospace; */
}
body{
  line-height: inherit;
  margin: calc(var(--space) * 2);
}
body > header{
  max-width: 720px;
}

*::selection{
  background-color: var(--acc-clr);
}

a,
a:visited{
  color: var(--acc-clr);
}

/* A GRID SECTION
  ===========================================================================*/

header{
  margin-bottom: calc(var(--space) * 4);
}
main > section + section{
  margin-top: calc(var(--space) * 4);
}
h1, h2{
  font-size: 2rem;
  max-width: 16em;
  line-height: 1.2;
}
h1 + p, h2 + p{
  margin-top: var(--space);
}

.music-list{
  --size: 1100px;
  max-width: var(--size);
  margin: calc(var(--space) * 2) auto;
}


/* the grid */
body.grid .music-list{
  --max-number-of-cell-per-row: 4;
  --grid-gap: calc(var(--space) * 3);

  /* so when it's in max size we have defined max number of cells */
  --min-cell-size:
    calc(
      (var(--size) - (var(--grid-gap) * (var(--max-number-of-cell-per-row) - 1)))
      / var(--max-number-of-cell-per-row)
    );

  box-sizing: content-box;
  display: grid;

  grid-template-columns: repeat(auto-fill, minmax(var(--min-cell-size), 1fr));
  grid-gap: var(--grid-gap);
}

footer{
  margin-top: calc(var(--space) * 8);
  text-align: right;
  font-size: smaller;
}

/* A RELEASE / TRACK
  ===========================================================================*/

.music{
  position: relative;
}

/* _____ UPPER PART _____ */

/* single-track picto */
body.grid .music.single-track::before{
  content: "";
  display: block;
  box-sizing: border-box;
  height: calc(var(--space) * 1);
  width: calc(var(--space) * 1.5);
  border: 1.5px solid var(--soft-clr);
  border-radius: calc(var(--space) * 1.5);
  border-top-right-radius: 0;
  border-bottom-right-radius: calc(var(--space) * 3);

  margin-bottom: calc(var(--space) * 0.5);
}

/* cover art
is cropped to a square using the padding trick*/
.music .music__cover{
  display: block;
  padding-top: 100%;
  position: relative;

  margin-bottom: calc(var(--space) * 0.5);
}
.music .music__cover img{
  display: block;
  position: absolute;
  width: 100%;
  height: 100%;
  inset: 0;
  object-fit: cover;
  object-position: center;

  /* for alt text */
  color: var(--soft-clr);
}
.music .music__cover.no-cover{
  border: 1.5px solid var(--soft-clr);
}
.music .music__cover.no-cover img{
  display: none;
}

/* _____ TEXT PART _____ */

/* layout */
.music > .music__info{
  display: grid;
  grid-template-columns: 1fr min-content;
  grid-gap: 0 var(--space);
}
.music__info > .primary-info,
.music__info > .secondary-info{
  display: contents;
}
.music__info > * > *{
  grid-column: 1 / span 2;
}
.music__info > .primary-info > .music__name{
  grid-column: 1 / span 1;
  grid-row: 1;
}
.music__info > .music__link{
  grid-column: 2 / span 1;
  grid-row: 1;
}
.music__artist{
  margin-bottom: calc(var(--space) * 0.25);
}

/* text styling */
.music__name{
  font-weight: bold;
}
.music__artist{
  font-style: italic;
}
.smaller{
  font-size: smaller;
}
.music__link a{
  text-decoration: none;
}
.music__type{
  white-space: nowrap;
  text-transform: uppercase;
}
.music__tags{
  color: var(--soft-clr);
}
.music__tags li{
  font-style: italic;
}
.recording-info__releases li > span{
  font-style: italic;
  font-weight: bold;
}

/* comma list */
:is(.comma-list, .only-comma-list){
  display: inline;
}
:is(.comma-list, .only-comma-list) li{
  display: inline;
}
:is(.comma-list, .only-comma-list) li:not(:first-child)::before{
  content: ', ';
}
.comma-list li:not(:first-child):last-child::before{
  content: ' and ';
}



/* _____ LIST VERSION _____ */

/* main */
body:not(.grid) .music .music__cover{
  display: none;
}
body:not(.grid) .music-list{
  --size: 720px;
  list-style: revert;
  padding-left: calc(var(--space) * 1.5);
}

/* layout */
body:not(.grid) .music{
  padding: 0 calc(var(--space) / 2);
}
body:not(.grid) .music:not(:last-of-type){
  margin-bottom: calc(var(--space) / 2);
}
body:not(.grid) .music.single-track{
  list-style-type: "–";
}

/* primary info on same line */
body:not(.grid) .music__info > .primary-info{
  display: block;

  grid-column: 1 / span 1;
  grid-row: 1;
}
body:not(.grid) .music :is(h3, h4){
  display: inline;
  margin: 0;
}
body:not(.grid) .music h4::before{
  content: "—";
}

/* secondary info on same line */
body:not(.grid) .music__info > .secondary-info{
  display: block;
  grid-column: 1 / span 2;
}
body:not(.grid) .music__info > .secondary-info > *{
  display: inline;
}
body:not(.grid) .music__info > .secondary-info > *:not(:last-of-type){
  margin-right: 0.5em;
}


/* CONTROLS
  ===========================================================================*/

.controls{
  position: fixed;
  top: var(--space);
  right: var(--space);
  z-index: 5;
}
.controls button{
  /* background-color: var(--soft-clr); */
  padding: calc(var(--space) * 0.5) calc(var(--space) * 1);
  text-transform: uppercase;
  border: 1px solid black;
}

body:not(.grid) .list-grid-toggle__list{
  color: var(--acc-clr);
}
body.grid .list-grid-toggle__grid{
  color: var(--acc-clr);
}

/* MOBILE
  ===========================================================================*/

@media only screen and (max-width: 600px) {
  /* controls */
  .controls{
    position: fixed;
    top: auto;
    left: 0;
    bottom: 0;
    right: 0;
  }
  .controls button{
    width: 100%;
    border: none;
    border-radius: 0;
    border-top: 1px solid black;
  }
  footer{
    margin-bottom: calc(var(--space) * 4);
  }

  /* font sizes and spacing */
  h1, h2{
    font-size: 1.5rem;
    line-height: 1.2;
  }
  body{
    margin: calc(var(--space) * 1);
  }
  body:not(.grid) .music-list {
    padding-left: calc(var(--space) * 1);
  }

  body:not(.grid) .music__info > .secondary-info > .music__tags{
    display: block;
    margin-left: 0;
  }
  footer{
    text-align: left;
  }

}

/* PRINT
  ===========================================================================*/

@media print{
  html{
    background: white;
    color: var(--clr);
    font-size: 12pt;
  }
  .controls{
    display: none;
  }

  /* remove links and thus reset info width */
  .music__link{
    display: none;
  }

  .music-list{
    --size: 100%;
  }

}
